summaryrefslogtreecommitdiff
path: root/src/osdef.sh
diff options
context:
space:
mode:
authorBram Moolenaar <Bram@vim.org>2004-06-13 20:20:40 +0000
committerBram Moolenaar <Bram@vim.org>2004-06-13 20:20:40 +0000
commit071d4279d6ab81b7187b48f3a0fc61e587b6db6c (patch)
tree221cbe3c40e043163c06f61c52a7ba2eb41e12ce /src/osdef.sh
parentb4210b3bc14e2918f153a7307530fbe6eba659e1 (diff)
downloadvim-git-071d4279d6ab81b7187b48f3a0fc61e587b6db6c.tar.gz
updated for version 7.0001v7.0001
Diffstat (limited to 'src/osdef.sh')
-rwxr-xr-xsrc/osdef.sh99
1 files changed, 99 insertions, 0 deletions
diff --git a/src/osdef.sh b/src/osdef.sh
new file mode 100755
index 000000000..d7d4f2ac2
--- /dev/null
+++ b/src/osdef.sh
@@ -0,0 +1,99 @@
+#! /bin/sh
+#
+# osdef.sh -- copy osdef.h.in to osdef.h while removing declarations
+# found in the system header files. Caution: weird sed magic going on here.
+# Warnings are printed if sed did not survive.
+#
+# (C) Michael Schroeder, Juergen Weigert
+#
+# osdef.h.in has been split into osdef1.h.in and osdef2.h.in, because some
+# sed's could not handle the amount of commands (is 50 commands the limit?).
+#
+# 31.10.95 jw.
+
+if test -z "$CC"; then
+ CC=cc
+fi
+if test -z "$srcdir"; then
+ srcdir=.
+fi
+
+rm -f core* *.core
+
+cat << EOF > osdef0.c
+#ifndef __APPLE__
+# define select select_declared_wrong
+#endif
+#define tgetstr tgetstr_declared_wrong
+#include "auto/config.h"
+#include "os_unix.h" /* bring in most header files, more follow below */
+#include "os_unixx.h" /* bring in header files for os_unix.c */
+
+#ifdef HAVE_TERMCAP_H
+# include <termcap.h> /* only for term.c */
+#endif
+
+#ifdef HAVE_FCNTL_H
+# include <fcntl.h> /* only used in a few files */
+#endif
+
+#ifdef HAVE_SYS_STATFS_H
+# include <sys/types.h>
+# include <sys/statfs.h> /* only for memfile.c */
+#endif
+
+#ifdef HAVE_X11
+# include <X11/Intrinsic.h>
+#endif
+EOF
+
+# Mac uses precompiled headers, but we need real headers here.
+case `uname` in
+ Darwin) $CC -I. -I$srcdir -E -no-cpp-precomp osdef0.c >osdef0.cc;;
+ *) $CC -I. -I$srcdir -E osdef0.c >osdef0.cc;;
+esac
+
+# insert a space in front of each line, so that a function name at the
+# start of the line is matched with "[)*, ]\1[ (]"
+sed < osdef0.cc -e '/\(..*\)/s// \1/' > osdef0.ccc
+
+sed < $srcdir/osdef1.h.in -n -e '/^extern/s@.*[)* ][)* ]*\([a-zA-Z_][a-zA-Z0-9_]*\) __ARGS.*@/[)*, ][(]*\1[)]*[ (]/i\\\
+\\/\\[^a-zA-Z_\\]\1 __ARGS\\/d@p' > osdef11.sed
+
+sed < $srcdir/osdef2.h.in -n -e '/^extern/s@.*[)* ][)* ]*\([a-zA-Z_][a-zA-Z0-9_]*\) __ARGS.*@/[)*, ][(]*\1[)]*[ (]/i\\\
+\\/\\[^a-zA-Z_\\]\1 __ARGS\\/d@p' > osdef21.sed
+
+cat << EOF > osdef2.sed
+1i\\
+/*
+1i\\
+ * osdef.h is automagically created from osdef?.h.in by osdef.sh -- DO NOT EDIT
+1i\\
+ */
+EOF
+
+cat osdef0.ccc | sed -n -f osdef11.sed >> osdef2.sed
+sed -f osdef2.sed < $srcdir/osdef1.h.in > auto/osdef.h
+
+cat osdef0.ccc | sed -n -f osdef21.sed > osdef2.sed
+sed -f osdef2.sed < $srcdir/osdef2.h.in >> auto/osdef.h
+
+rm osdef0.c osdef0.cc osdef0.ccc osdef11.sed osdef21.sed osdef2.sed
+
+if test -f core*; then
+ file core*
+ echo " Sorry, your sed is broken. Call the system administrator."
+ echo " Meanwhile, you may try to compile Vim with an empty osdef.h file."
+ echo " If you compiler complains about missing prototypes, move the needed"
+ echo " ones from osdef1.h.in and osdef2.h.in to osdef.h."
+ exit 1
+fi
+cat $srcdir/osdef1.h.in $srcdir/osdef2.h.in >osdefX.h.in
+if eval test "`diff auto/osdef.h osdefX.h.in | wc -l`" -eq 4; then
+ echo " Hmm, sed is very pessimistic about your system header files."
+ echo " But it did not dump core -- strange! Let's continue carefully..."
+ echo " If this fails, you may want to remove offending lines from osdef.h"
+ echo " or try with an empty osdef.h file, if your compiler can do without"
+ echo " function declarations."
+fi
+rm osdefX.h.in